package net.darkmist.defcon18;

import java.io.InputStream;
import java.io.IOException;
import java.io.Reader;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class DecodingStream extends InputStream
{
	@SuppressWarnings("unused")
	private static final Logger logger = LoggerFactory.getLogger(DecodingStream.class);
	private Reader reader;

	DecodingStream(Reader reader_arg)
	{
		reader = reader_arg;
	}

	private int getNibble() throws IOException
	{
		int ch;

		do
		{
			if((ch = reader.read())<0)
				return -1;
			//logger.debug("read '" + ch + "'");
			if('0' <= ch && ch <= '9')
				return ch - '0';
			if('a' <= ch && ch <= 'f')
				return ch - 'a' + 10;
			if('A' <= ch && ch <= 'F')
				return ch - 'A' + 10;
			// default... ignore
		} while(true);
	}

	@Override
	public int read() throws IOException
	{
		int hi;
		int low;

		if((hi = getNibble())<0)
			return -1;
		if((low = getNibble())<0)
			return -1;
		return (hi<<4)|(low);
	}

	@Override
	public void close() throws IOException
	{
		reader.close();
	}
}

